<?php

declare(strict_types=1);

$finder = PhpCsFixer\Finder::create()
    ->in(__DIR__)
    ->exclude('.idea')
    ->exclude('config/packages')
    ->exclude('config/routes')
    ->exclude('config/services')
    ->exclude('tests/_output/')
    ->exclude('tests/_support/_generated/')
    ->exclude('var')
    // Exclude files generated by Symfony Flex recipes
    ->notPath('bin/console')
    ->notPath('public/index.php')
;

return (new PhpCsFixer\Config())
    ->setRiskyAllowed(true)
    ->setRules([
        '@PhpCsFixer' => true,
        '@PhpCsFixer:risky' => true,
        '@PHP80Migration' => true,
        '@PHP80Migration:risky' => true,
        '@DoctrineAnnotation' => true,
        'method_argument_space' => [
            'after_heredoc' => true,
            'keep_multiple_spaces_after_comma' => false,
            'on_multiline' => 'ensure_single_line',
        ],
        'no_extra_blank_lines' => [
            'tokens' => [
                'break',
                'case',
                'continue',
                'curly_brace_block',
                'default',
                'extra',
                'parenthesis_brace_block',
                'return',
                'square_brace_block',
                'switch',
                'throw',
                // Commenting the "use" part because PHP-CS-Fixer doesn't manage this PSR12 rule well
                // 'use',
                'use_trait',
            ],
        ],
        'php_unit_test_class_requires_covers' => false,
        'single_line_comment_style' => [
            'comment_types' => ['hash'],
        ],
        'no_superfluous_phpdoc_tags' => false,
        'ordered_imports' => [
            'imports_order' => [
                'class',
                'function',
                'const',
            ],
            'sort_algorithm' => 'alpha',
        ],
        'phpdoc_to_comment' => false,
        'comment_to_phpdoc' => false,
        'mb_str_functions' => true,
        'phpdoc_line_span' => [
            'const' => 'multi',
            'method' => 'multi',
            'property' => 'multi',
        ],
        'global_namespace_import' => [
            'import_classes' => true,
            'import_constants' => true,
            'import_functions' => true,
        ],
    ])
    ->setFinder($finder)
    ->setCacheFile(__DIR__.'/var/cache/.php-cs-fixer.cache')
;
